"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var libs_1 = require("./libs");
var util_1 = require("./util");
function info(pkg) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var modules, items;
        var _this = this;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    modules = (Array.isArray(pkg) ? pkg : [pkg]).filter(function (pkg) { return pkg.json.private !== true; });
                    return [4, Promise.all(modules.map(function (item) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                            var name_1, version, latest, res, error_1, message;
                            return tslib_1.__generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        name_1 = item.name;
                                        version = item.version;
                                        return [4, libs_1.npm.getVersion(item.name)];
                                    case 1:
                                        latest = _a.sent();
                                        res = { name: name_1, version: version, latest: latest };
                                        return [2, res];
                                    case 2:
                                        error_1 = _a.sent();
                                        message = "Failed getting NPM info for '" + item.name + "'. " + error_1.message;
                                        throw new Error(message);
                                    case 3: return [2];
                                }
                            });
                        }); }))];
                case 1:
                    items = _a.sent();
                    return [2, util_1.compact(items)];
            }
        });
    });
}
exports.info = info;
